import java.awt.*;
import java.awt.event.*;
import java.applet.*;

import gnu.io.CommPort;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;

import java.io.FileDescriptor;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class Schieber extends Scrollbar
{
    public Color[] blaurot;
    public TextField mTF;
    public Servotest applet;

    public double breite = 200.0;

    public static int anz = 0;

    public double min,max;
    public double faktor;
    
    public double[] wert;
    public int nr;
    
    public int istart;
    public Schieber(TwoWaySerialComm tw,Servotest applet,String name, String text, int YOFF, double[] wert,int nr, double min, double max,String groesse)
    {
      super(Scrollbar.HORIZONTAL,0,10,0,210);    

      this.applet = applet;
      this.blaurot = Farben.blaurot;
    
      this.wert = wert;
      this.nr   = nr;
      
      this.min = min;
      this.max = max;
      
      faktor = breite / (max-min);
      istart = (int)((wert[nr] - min)*faktor);
      setValue(istart);      
            
      setBackground(new Color(200,200,255));
      setBounds(150,anz*20+YOFF,210,18);
      
      Label l = new Label(text);
      l.setBounds(5,anz*20+YOFF,100,18);
      l.setBackground(new Color(255,255,255));

      Label l2 = new Label(name+"=");
      l2.setBounds(107,anz*20+YOFF,40,18);
      l2.setBackground(new Color(255,255,255));
      
      mTF = new TextField(""+wert[nr]);
      mTF.addActionListener(new TextLauscher(this));
      mTF.setBounds(360,anz*20+YOFF,70,18);

      Label l3 = new Label(groesse);
      l3.setBounds(432,anz*20+YOFF,50,18);
      l3.setBackground(new Color(255,255,255));

      applet.add(this);
      applet.add(l);     
      applet.add(l2);     
      applet.add(mTF);
      applet.add(l3);     
      
      addAdjustmentListener(new SchieberLauscher(tw,this));
      
      anz++;            
    }
}
