//Jetzt auch eine Visualisierung fr die Positon des Servos und des Pendels einbauen:

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

import gnu.io.CommPort;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;

import java.io.FileDescriptor;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import java.awt.*;

public class Servotest extends Applet
{
    public Button knopf;
    public TextArea textbereich;
    public Schieber servo_schieber;
                    
    public TwoWaySerialComm rs232;                    
            
    public double[] parameter = {0.0}; //0.:Servo            
                                
    public void init()
    {
        setBackground(new Color(255,255,255));
    
System.out.println("A");        
        Farben.init();
System.out.println("B");        
        rs232 = new TwoWaySerialComm();
System.out.println("C");        
        try
        {
            rs232.connect("COM1");
        }
        catch ( Exception eee )
        {
            eee.printStackTrace();
        }
System.out.println("Modus 8 whlen.");        
        rs232.senden="8#";
    
        setLayout(null);
    
        knopf = new Button("Exit");
            
        add(knopf);   
        knopf.addActionListener(new Listener("java Modewahl"));         
        knopf.setLocation(0,10);
        knopf.setSize(190,20);
        
        textbereich = new TextArea("Empfangene Zeilen von Mikrocontroller",8,50,TextArea.SCROLLBARS_BOTH);
        add(textbereich);
        textbereich.setLocation(5,30);        
        textbereich.setSize(400,400);
        
        rs232.registriereTextbereich(textbereich);
        rs232.registriereParameter(parameter);
        
            servo_schieber = new Schieber(rs232,this,
                         "pwm", 
                         "Servo",
                         500, 
                         parameter,
                         0,
                         -45.0,
                          45.0,
                         "Grad");
        
    }

    public void start()
    {
    }

    public void paint(Graphics g)
    {    
        g.setColor(new Color(200,255,200));
        g.fillRect(5,5,200,100);
        
        ZeigeServo.zeichnen(parameter[0],g);
    }

    public class Listener implements ActionListener
    {
        String befehl;

        Listener(String befehl)
        {
            this.befehl = befehl;
        }
        
        public void actionPerformed(ActionEvent e)
        {
            //Externes Programm ausfhren und das aktuelle Programm beenden.
            try
            {            
                String senden = "$#\n\r";
                byte[] puffer = senden.getBytes();
                for(int i=0;i<puffer.length;i++)
                rs232.writer.out.write((int)puffer[i]);
                repaint();

                Thread.sleep(1000);
            
                Runtime.getRuntime().exec(befehl);
            }
            catch(Exception ee)
            {
            }                
            System.exit(0);
        }
    }

    public static void main(String[] args)
    {
        Servotest mw = new Servotest();
        mw.init();
        mw.start();
        mw.repaint();

        JFrame mF = new JFrame("Servotest: Servo ber Schieberegler ansteuern");
        mF.getContentPane().add(mw);
        mF.pack();
        mF.setSize(1000,700);
        mF.setLocation(2,2);
        mF.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        mF.setVisible(true);
    }
}

