import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;


public class Modewahl extends Applet
{
    public Button[] knopf;
    public String[] modetext = {"Servotest",
                                "Lerne Aufschwingen",
                                "Servo-Identifikation",
                                "Regler-Auslegung",
                                "Reglerparameter-Test",
                                "Regler-Demo"
                                };

    public String[] befehl   = {"java Servotest",
                                "java LerneAufschwingen",
                                "java Servoidentifikation",
                                "java Reglerauslegung",
                                "java Reglerparametertest",
                                "java Reglerdemo"
                                };

                                
    public void init()
    {
        knopf = new Button[6];
        for(int i=0;i<knopf.length;i++)
            knopf[i] = new Button(modetext[i]);
            
        for(int i=0;i<knopf.length;i++)
        {            
            add(knopf[i]);   
            knopf[i].addActionListener(new Listener(befehl[i]));         
            knopf[i].setLocation(i*200,10);
            knopf[i].setSize(190,20);
        }            
    }

    public void start()
    {
    }

    public void paint(Graphics g)
    {    
        g.setColor(new Color(200,255,200));
        g.fillRect(5,5,200,100);
    }

    public class Listener implements ActionListener
    {
        String befehl;

        Listener(String befehl)
        {
            this.befehl = befehl;
        }
        
        public void actionPerformed(ActionEvent e)
        {
            //Externes Programm ausfhren und das aktuelle Programm beenden.
            try
            {            
                Runtime.getRuntime().exec(befehl);
            }
            catch(Exception ee)
            {
            }                
            System.exit(0);
        }
    }


    public static void main(String[] args)
    {
        Modewahl mw = new Modewahl();
        mw.init();
        mw.start();
        mw.repaint();

        JFrame mF = new JFrame("Auswahl der Betriebsmodi des Balancierers");
        mF.getContentPane().add(mw);
        mF.pack();
        mF.setSize(700,100);
        mF.setLocation(2,2);
        mF.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        mF.setVisible(true);
    }
}
