import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class Reglerdemo extends Applet
{
    public Button knopf;
    public TextArea textbereich;

                    
    public TwoWaySerialComm2 rs232;                    
                                
    public void init()
    {
        rs232 = new TwoWaySerialComm2();
        try
        {
            rs232.connect("COM1");
        }
        catch ( Exception eee )
        {
            eee.printStackTrace();
        }
        rs232.senden="1#";
    
        setLayout(null);
    
        knopf = new Button("Exit");
            
        add(knopf);   
        knopf.addActionListener(new Listener("java Modewahl"));         
        knopf.setLocation(0,10);
        knopf.setSize(190,20);
        
        textbereich = new TextArea("Empfangene Zeilen von Mikrocontroller",8,50,TextArea.SCROLLBARS_BOTH);
        add(textbereich);
        textbereich.setLocation(5,30);        
        textbereich.setSize(400,400);
        
        rs232.registriereTextbereich(textbereich);
    }

    public void start()
    {
    }

    public void paint(Graphics g)
    {    
        g.setColor(new Color(200,255,200));
        g.fillRect(5,5,200,100);
    }

    public class Listener implements ActionListener
    {
        String befehl;

        Listener(String befehl)
        {
            this.befehl = befehl;
        }
        
        public void actionPerformed(ActionEvent e)
        {
            //Externes Programm ausfhren und das aktuelle Programm beenden.
            try
            {            
                Runtime.getRuntime().exec(befehl);
            }
            catch(Exception ee)
            {
            }                
            System.exit(0);
        }
    }

    public static void main(String[] args)
    {
        Reglerdemo mw = new Reglerdemo();
        mw.init();
        mw.start();
        mw.repaint();

        JFrame mF = new JFrame("Servotest: Servo ber Schieberegler ansteuern");
        mF.getContentPane().add(mw);
        mF.pack();
        mF.setSize(1000,700);
        mF.setLocation(2,2);
        mF.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        mF.setVisible(true);
    }
}

