import java.awt.*;
import java.awt.event.*;
import java.applet.*;

import gnu.io.CommPort;
import gnu.io.CommPortIdentifier;
import gnu.io.SerialPort;

import java.io.FileDescriptor;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class SchieberLauscher implements AdjustmentListener
{
    public Schieber schieber;

    public TwoWaySerialComm tw;

    SchieberLauscher(TwoWaySerialComm tw,Schieber schieber)
    {
        this.schieber = schieber;
        this.tw   = tw;
    }

    public void adjustmentValueChanged(AdjustmentEvent e)
    {
        schieber.wert[schieber.nr] = ((double)e.getValue()/schieber.breite)*(schieber.max-schieber.min) + schieber.min;
        
        schieber.setBackground(schieber.blaurot[e.getValue()]);                  
        schieber.mTF.setText(""+schieber.wert[schieber.nr]);

        try
        {
        String senden = ""+(int)(2304.0*schieber.wert[schieber.nr]/45.0+0.5)+"#";
        byte[] puffer = senden.getBytes();
        for(int i=0;i<puffer.length;i++)
            tw.writer.out.write((int)puffer[i]);
        }
        catch(Exception xxx)
        {
        }
//        schieber.applet.simulieren();
        schieber.applet.repaint();
    }    
}
